'
' ClearLNK by Alex Dragokas ver.1.2
' 
'      (.LNK)
'    ,     URL.
'
' :
'  -  1)         
'  -  2)       CheckBrowserLNK
'  -  3)          
'  (        ,      )
'

Option Explicit

Dim oShellApp: Set oShellApp = CreateObject("Shell.Application")
Dim oShell:    Set oShell    = CreateObject("WScript.Shell")
Dim oFSO:      Set oFSO      = CreateObject("Scripting.FileSystemObject")
Dim LNK, arg
Dim ver: ver = "1.2"
Dim cur

cur = oFSO.GetParentFolderName(WScript.ScriptFullName)

If WScript.Arguments.Count > 0 then 
	LNK = WScript.Arguments(0)
	if not CureObject(LNK) then msgbox "     !": WScript.Quit 1
else
	arg = inputbox("    ","ClearLNK ver." & ver,cur & "\")
	if arg = "" then WScript.Quit
	LNK = FindLNK(arg)
	if LNK = "" then msgbox "     !": WScript.Quit 1
	call CureObject(LNK)
end if

msgbox ".", vbInformation, "ClearLNK ver." & ver

Function CureObject(file)
	CureObject = true
	if not oFSO.FileExists(file) then Exit Function
	Select Case CheckValidExtension(file)
	Case ""
		CureObject = false
	Case "LNK"
		call FixLNK(file)
	Case "URL"
		call FixURL(file)
	Case "LOG"
		call ParseLOG(file)
	End Select
End Function

Function FixLNK(file)
	on error resume next
	Dim ClearBrowserPath
	call CheckPrivileges(oFSO.GetParentFolderName(file))
	with oShell
		with .CreateShortcut(file)
			Dim LNK_Targ:   LNK_Targ   = .TargetPath
			Dim LNK_Args:	LNK_Args   = .Arguments
			Dim LNK_Descr:  LNK_Descr  = .Description
			Dim LNK_Key:    LNK_Key    = .HotKey
			Dim LNK_Icon:   LNK_Icon   = .IconLocation
			Dim LNK_Style:  LNK_Style  = .WindowStyle
			Dim LNK_WDir:   LNK_WDir   = .WorkingDirectory
		end with

		'    cmd.exe
		if LCase(oFSO.GetBaseName(LNK_Targ)) = "cmd" then
			ClearBrowserPath = FindKnownBrowserName(LNK_Args)
			if ClearBrowserPath = "" then
				Exit Function
			else
				LNK_Targ = ClearBrowserPath
			end if
		end if

		'      URL
		Dim Ext, Relink, AssumeOK
		Relink = false: AssumeOK = false
		Ext = LCase(oFSO.GetExtensionName(LNK_Targ))
		if Ext = "url" then
			Relink = true
			'   URL  EXE
			LNK_Targ = oFSO.GetParentFolderName(LNK_Targ) & "\" & oFSO.GetBaseName(LNK_Targ) & ".exe"
			if oFSO.FileExists(LNK_Targ) then AssumeOK = true '  
		end if

		oFSO.DeleteFile file, true
		if Err <> 0 then call Elevate()
		
		Dim ArgIsSafe, Ch ' ,     (   -  /)
		Ch = Left(LNK_Args, 1)
		ArgIsSafe = (Ch = "-" or Ch = "/")

		with .CreateShortcut(file)
			.Description        = LNK_Descr
			.HotKey             = LNK_Key
			.IconLocation       = LNK_Icon
			.TargetPath         = LNK_Targ
			.WindowStyle        = LNK_Style
			.WorkingDirectory   = LNK_WDir
			if Relink and ArgIsSafe then .Arguments = LNK_Args
			.Save
		end with
	end with
	if Relink and not AssumeOK then msgbox " ,       ." & vbCrLf & _
										   "Windows    ." & vbCrLf &_
										   "   ."
End Function

Function FindKnownBrowserName(Str)
	On Error Resume Next
    Dim oRegEx, oMatches, Browser, Ext, ParentPath, sPath
    Set oRegEx = CreateObject("VBScript.RegExp")
    oRegEx.IgnoreCase = True
    oRegEx.Global = True
    oRegEx.Pattern = "("".:\\[^""]*\\|.:\\[^ ""]*\\|"")?" & _
                     "(iexplore|chrome|firefox|opera|browser|dragon|icedragon|" & _
                     "nichrome|seamonkey)(\.exe)?""?"
    Set oMatches = oRegEx.Execute(Str)
    If oMatches.Count Then
        Browser = oMatches.Item(0).Value
        ParentPath = oFSO.GetParentFolderName(Browser)
        Ext = oFSO.GetExtensionName(Browser)
        If Ext = "" Then Browser = Browser & ".exe"
        If ParentPath = "" Then '      ,    App Path
            Browser = UnQuote(Browser)
            sPath = oShell.RegRead("HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\" & Browser & "\Path")
            sPath = Split(sPath, ";")(0)
            Browser = sPath & "\" & Browser
        End If
        FindKnownBrowserName = Browser
    Else    '       .
        MsgBox "     ." & vbCrLf & ",    : Audilyzer@i.ua"
    End If
    Set oRegEx = Nothing
End Function

Function UnQuote(Str)
    Dim s: s = Str
    Do While Left(s, 1) = """"
        s = Mid(s, 2)
    Loop
    Do While Right(s, 1) = """"
        s = Left(s, Len(s) - 1)
    Loop
    UnQuote = s
End Function

Function FixURL(file)
	on error resume next
	call CheckPrivileges(oFSO.GetParentFolderName(file))
	with oShell
		with .CreateShortcut(file)
			Dim URL_Targ:   URL_Targ   = .TargetPath
		end with

		oFSO.DeleteFile file, true
		if Err <> 0 then call Elevate()

		with .CreateShortcut(file)
			.TargetPath   = URL_Targ
			.Save
		end with
	end with
End Function

Function ParseLOG(file)
	Dim arr:	arr = ReadFileToArray(file, "UTF-16LE", "windows-1251")
	Dim Line, LinksBegin
	LinksBegin = false
	For each Line in arr
		if LinksBegin then
			if left(Line, 3) = "===" then Exit Function
			call ParseLogLine(Line)
		end if
		if instr(1, Line, "[ Browser with parameters ]", 1) <> 0 then LinksBegin = true
	Next
End Function

Function ParseLogLine(Line)
	dim pos, file
	pos = 0
	Do
		pos = pos + 1
		pos = instr(pos, Line, "[")
		if pos <> 0 then 
			file = trim(left(Line, pos - 1))
			if oFSO.FileExists(file) then
				call CureObject(file) '   (main -> CureObject -> ParseLOG -> ParseLogLine -> CureObject)
				Exit Do
			end if
		end if
	Loop while pos
End function

Function FindLNK(file) ' LNK, URL  LOG,      
	Dim Ext
	For each Ext in Array("", ".LNK", ".LOG") '".URL"
		if oFSO.FileExists(file & Ext) then FindLNK = file & Ext: Exit For
	Next
End Function

Function CheckValidExtension(file)
	Dim Ext
	For each Ext in Array("LNK", "LOG") '"URL"
		if UCase(oFSO.GetExtensionName(file)) = Ext then CheckValidExtension = Ext: Exit For
	Next	
End Function

Sub Elevate()
    if msgbox("  ." & vblf & " ClearLNK    ?",vbQuestion+vbYesNo,"") = vbNo then WScript.Quit 5    
    oShellApp.ShellExecute WScript.FullName, """" & WScript.ScriptFullName & """" & " " & """" & LNK & """", "", "runas", 1
	WScript.Quit 0
End Sub

Function ReadFileToArray(file, srcEncode, destEncode)
	Dim Text
    With CreateObject("ADODB.Stream")
		.Type = 2
		.Charset = srcEncode
        .Open
		.LoadFromFile file
		if .Size = 0 then WScript.Quit 2
		Text = .ReadText()
		.Close
		.Charset = destEncode
		.Open
		.WriteText (Text)
		.Position = 0
		Text = .ReadText()
		.Close
	end with
	ReadFileToArray = Split(Text, vbCrLf)
End Function

Function CheckPrivileges(path)
	dim tmpfile, oTSW
	tmpfile = oFSO.BuildPath(path, oFSO.GetTempName())
	if oFSO.FileExists(tmpfile) then
		call GetTempFileName(path)
	else
		on error resume next
		set oTSW = oFSO.CreateTextFile(tmpfile,false)
		if err <> 0 then
			call Elevate()
		else
			oTSW.Close
			oFSO.DeleteFile tmpfile
		end if
	end if
End Function
